InstrumentableClassLoader (Apache Tomcat 9.0.102 API Documentation)
Description: declaration: package: org.apache.tomcat, interface: InstrumentableClassLoader

Package org.apache.tomcat

# Interface InstrumentableClassLoader

All Known Implementing Classes:
  `ParallelWebappClassLoader`, `WebappClassLoader`, `WebappClassLoaderBase`

public interface InstrumentableClassLoader
Specifies a class loader capable of being decorated with `ClassFileTransformer`s. These transformers can instrument (or weave) the byte code of classes loaded through this class loader to alter their behavior. Currently only `WebappClassLoaderBase` implements this interface. This allows web application frameworks or JPA providers bundled with a web application to instrument web application classes as necessary.

You should always program against the methods of this interface (whether using reflection or otherwise). The methods in `WebappClassLoaderBase` are protected by the default security manager if one is in use.

Since:
  8.0, 7.0.64

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addTransformer(ClassFileTransformer transformer)`
  Adds the specified class file transformer to this class loader.
  `ClassLoader`
  `copyWithoutTransformers()`
  Returns a copy of this class loader without any class file transformers.
  `void`
  `removeTransformer(ClassFileTransformer transformer)`
  Removes the specified class file transformer from this class loader.

- ## Method Details

  - ### addTransformer

    void addTransformer(ClassFileTransformer transformer)
    Adds the specified class file transformer to this class loader. The transformer will then be able to instrument the bytecode of any classes loaded by this class loader after the invocation of this method.
    Parameters:
      `transformer` - The transformer to add to the class loader
    Throws:
      `IllegalArgumentException` - if the transformer is null.

  - ### removeTransformer

    void removeTransformer(ClassFileTransformer transformer)
    Removes the specified class file transformer from this class loader. It will no longer be able to instrument the byte code of any classes loaded by the class loader after the invocation of this method. However, any classes already instrumented by this transformer before this method call will remain in their instrumented state.
    Parameters:
      `transformer` - The transformer to remove

  - ### copyWithoutTransformers

    ClassLoader copyWithoutTransformers()
    Returns a copy of this class loader without any class file transformers. This is a tool often used by Java Persistence API providers to inspect entity classes in the absence of any instrumentation, something that can't be guaranteed within the context of a `ClassFileTransformer`'s `transform` method.

    The returned class loader's resource cache will have been cleared so that classes already instrumented will not be retained or returned.

    Returns:
      the transformer-free copy of this class loader.